/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-bayesian-belief-networks-1.0.40-0precise-20140920-0057/msg/Observation.msg
 *
 */


#ifndef BAYESIAN_BELIEF_NETWORKS_MESSAGE_OBSERVATION_H
#define BAYESIAN_BELIEF_NETWORKS_MESSAGE_OBSERVATION_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace bayesian_belief_networks
{
template <class ContainerAllocator>
struct Observation_
{
  typedef Observation_<ContainerAllocator> Type;

  Observation_()
    : node()
    , evidence()  {
    }
  Observation_(const ContainerAllocator& _alloc)
    : node(_alloc)
    , evidence(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _node_type;
  _node_type node;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _evidence_type;
  _evidence_type evidence;




  typedef boost::shared_ptr< ::bayesian_belief_networks::Observation_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::bayesian_belief_networks::Observation_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Observation_

typedef ::bayesian_belief_networks::Observation_<std::allocator<void> > Observation;

typedef boost::shared_ptr< ::bayesian_belief_networks::Observation > ObservationPtr;
typedef boost::shared_ptr< ::bayesian_belief_networks::Observation const> ObservationConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::bayesian_belief_networks::Observation_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::bayesian_belief_networks::Observation_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace bayesian_belief_networks

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'bayesian_belief_networks': ['/tmp/buildd/ros-groovy-bayesian-belief-networks-1.0.40-0precise-20140920-0057/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::bayesian_belief_networks::Observation_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::bayesian_belief_networks::Observation_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::bayesian_belief_networks::Observation_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::bayesian_belief_networks::Observation_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::bayesian_belief_networks::Observation_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::bayesian_belief_networks::Observation_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::bayesian_belief_networks::Observation_<ContainerAllocator> >
{
  static const char* value()
  {
    return "381015522e25503885bf04a57ab55e63";
  }

  static const char* value(const ::bayesian_belief_networks::Observation_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x381015522e255038ULL;
  static const uint64_t static_value2 = 0x85bf04a57ab55e63ULL;
};

template<class ContainerAllocator>
struct DataType< ::bayesian_belief_networks::Observation_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bayesian_belief_networks/Observation";
  }

  static const char* value(const ::bayesian_belief_networks::Observation_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::bayesian_belief_networks::Observation_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string node\n\
string evidence\n\
";
  }

  static const char* value(const ::bayesian_belief_networks::Observation_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::bayesian_belief_networks::Observation_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.node);
      stream.next(m.evidence);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Observation_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::bayesian_belief_networks::Observation_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::bayesian_belief_networks::Observation_<ContainerAllocator>& v)
  {
    s << indent << "node: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.node);
    s << indent << "evidence: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.evidence);
  }
};

} // namespace message_operations
} // namespace ros

#endif // BAYESIAN_BELIEF_NETWORKS_MESSAGE_OBSERVATION_H
